package com.trs.ggzyexchange.schedul;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.AreaDataName;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.ScheduledTash;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.entity.ZrzyTdBidwinnotice;
import com.trs.ggzyexchange.entity.ZrzyTdCedeNotice;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.ScheduledTashService;
import com.trs.ggzyexchange.service.TenderDetailsVoService;
import com.trs.ggzyexchange.service.ZrzyTdCedeNoticeService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 出让公告信息 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-02-23
 */
@Component
public class ZrzyTdCedeNoticeSchedul    implements Job {

    private Logger logger = LoggerFactory.getLogger(ZrzyTdCedeNoticeSchedul.class);

    @Autowired
    private ZrzyTdCedeNoticeService zrzyTdCedeNoticeService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private ScheduledTashService scheduledTashService;

    public void queryPageListUpdateEs() throws JsonProcessingException {
        //查询当前在定时任务表当中的时间
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","zrzy_td_cede_notice");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                //查询表gcNoticeandfile表当中的最新时间
                time = zrzyTdCedeNoticeService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(time);
                scheduledTashTash.setTableNameValue("zrzy_td_cede_notice");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = zrzyTdCedeNoticeService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("zrzy_td_cede_notice");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        if(!ObjectUtils.isEmpty(time)){
            QueryWrapper<ZrzyTdCedeNotice> gcPerformanceQueryWrapper = new QueryWrapper<ZrzyTdCedeNotice>();
            gcPerformanceQueryWrapper.gt("DATA_TIMESTAMP",time);
            int count = zrzyTdCedeNoticeService.count(gcPerformanceQueryWrapper);
            Integer pageSize = 1000;
            Integer pageNum = (int)Math.ceil((double)count/pageSize);
            for(int i = 1; i <= pageNum;i++){
                List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
            }
        }
    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<ZrzyTdCedeNotice> page = new Page<ZrzyTdCedeNotice>(pageNo, pageSize);
        QueryWrapper<ZrzyTdCedeNotice> gcPerformanceQueryWrapper = new QueryWrapper<ZrzyTdCedeNotice>();
        gcPerformanceQueryWrapper.gt("DATA_TIMESTAMP",time);
        Page<ZrzyTdCedeNotice> pageList = zrzyTdCedeNoticeService.page(page,gcPerformanceQueryWrapper);
        List<TenderDetailsVo> tenderDetailsVoList = new ArrayList<TenderDetailsVo>();
        for (ZrzyTdCedeNotice record : pageList.getRecords()) {
            TenderDetailsVo tenderDetailsVo = new TenderDetailsVo();
            if(!ObjectUtils.isEmpty(record.getSourceDataKey())){
                tenderDetailsVo.setSourceDataKey(record.getSourceDataKey());
            }
            if(!ObjectUtils.isEmpty(record.getSourceDataCode())){
                tenderDetailsVo.setDataSourceCode(record.getSourceDataCode());
            }
            if(!ObjectUtils.isEmpty(record.getAnnouncementCode())){
                tenderDetailsVo.setProjectCode(record.getAnnouncementCode());
            }
            if(!ObjectUtils.isEmpty(record.getLandProjectName())){
                tenderDetailsVo.setProjectName(record.getLandProjectName());
            }
            if(!ObjectUtils.isEmpty(record.getAnnouncementGuid())){
                tenderDetailsVo.setTenderProjectCode(record.getAnnouncementGuid());
            }
            if(!ObjectUtils.isEmpty(record.getAnnouncementTitle())){
                tenderDetailsVo.setNoticeName(record.getAnnouncementTitle());
            }
            if(!ObjectUtils.isEmpty(record.getAnnouncementConnect())){
                tenderDetailsVo.setNoticeContent(record.getAnnouncementConnect());
            }
            Long publishingTime = record.getPublishingTime();
            if(!ObjectUtils.isEmpty(publishingTime)){
                tenderDetailsVo.setNoticeSendTime(record.getPublishingTime().toString());
            }
            if(!ObjectUtils.isEmpty(record.getLandDistrict())){
                tenderDetailsVo.setRegionCode(record.getLandDistrict());
            }
            if(!ObjectUtils.isEmpty(record.getContactPerson())){
                tenderDetailsVo.setBulletinDuty(record.getContactPerson());
            }
            if(!ObjectUtils.isEmpty(record.getDataSourceCode())){
                tenderDetailsVo.setDataSourceCode(record.getDataSourceCode());
            }
            Long announcementStartTime = record.getAnnouncementStartTime();
            if(!ObjectUtils.isEmpty(announcementStartTime)){
                tenderDetailsVo.setDocGetStartTime(announcementStartTime.toString());
            }
            Long announcementDeadline = record.getAnnouncementDeadline();
            if(!ObjectUtils.isEmpty(announcementDeadline)){
                tenderDetailsVo.setDocGetEndTime(announcementDeadline.toString());
                tenderDetailsVo.setBidDocReferEndTime(announcementDeadline.toString());
            }
            tenderDetailsVoList.add(tenderDetailsVo);
        }
        for (TenderDetailsVo record : tenderDetailsVoList) {
            try {
                record.setNoticeTypeCode(ClassIfy.TRANSFER_ANNOUNCEMENT.getCode());
                record.setNoticeTypeName(ClassIfy.TRANSFER_ANNOUNCEMENT.getName());
                record.setTransactionTypeCode(ClassIfy.NATURAL_RESOURCES.getCode());
                record.setTransactionTypeName(ClassIfy.NATURAL_RESOURCES.getName());
                record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
                TenderDetailsVoUtils.isNull(record);
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return tenderDetailsVoList;
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.ZrzyTdCedeNoticeFlag){
                JobLock.ZrzyTdCedeNoticeFlag = false;
                logger.info("执行ZrzyTdCedeNotice", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.ZrzyTdCedeNoticeFlag = true;
            }else{
                logger.info("不执行ZrzyTdCedeNotice", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
